<?php
//--------------------------------------------------------------------
// *** BlogTimes for BlognPlus ***
// LAST UPDATE: 2009/10/17
// Version    : 1.00
// Copyright  : nJOY
// http://i-njoy.net/
//--------------------------------------------------------------------
//
// main.php
//
//--------------------------------------------------------------------
function blogn_mod_blogtimes_chart($data, $ini) {
	$type = $ini["type"];
	$chcolor = $ini["chart"];
//	$data = array(10,0,0,0,0,0,0,0,0,7,0,0,0,0,0,0,0,0,5,0,0,0,0,0,0,0,0,3,0,0,0,0,0,0,0,0,1,0,0,0,0,0,0,0,0,3,0,0,0,0,0,0,0,0,5,0,0,0,0,0,0,0,0,7,0,0,0,0,0,0,0,0,10,0,0,0,0,0,0,0,0,7,0,0,0,0,0,0,0,0,5,0,0,0,0,0,0,0,0,3,0,0,0,0,0,0,0,0,1,0,0,0,0,0,0,0,0,3,0,0,0,0,0,0,0,0,5,0,0,0,0,0,0,0,0,7,0,0,0,0,0,0,0,10); // テスト用データ
	arsort($data);
	reset($data);
	$current = current($data);
	
	$height = ($type == 2) ? 40 : 30;
	$img = imagecreate(175, $height);

	$bg = imagecolorallocate($img, hexdec(substr($ini["bgcolor"], 0, 2)), hexdec(substr($ini["bgcolor"], 2, 2)), hexdec(substr($ini["bgcolor"], 4, 2)));
	
	$chart = array(
		"0" => array(255, 235, 225, 215, 205, 195, 185, 175, 165, 155, 125, 0, 50),
		"1" => array(50, 60, 70, 80, 90, 100, 110, 120, 130, 140, 160, 255, 220)
	);

	$background = imagecolorallocate($img, $chart[$chcolor][11], $chart[$chcolor][11], $chart[$chcolor][11]);
	$text = imagecolorallocate($img, hexdec(substr($ini["txtcolor"], 0, 2)), hexdec(substr($ini["txtcolor"], 2, 2)), hexdec(substr($ini["txtcolor"], 4, 2)));
	if ($type == 2) { // 音波形
		$col[11] = imagecolorallocate($img, $chart[$chcolor][12], $chart[$chcolor][12], $chart[$chcolor][12]);
		imagefilledrectangle($img, 14, 10, 161, 32, $background);
		if ($chcolor) {
			$line = imagecolorallocate($img, 255, 255, 255);
		} else {
			$line = imagecolorallocate($img, 0, 0, 0);
		}
		$style = array($line, $col[11], $col[11], $col[11], $colo[11]);
		imagesetstyle($img, $style);
		imageline($img, 52, 10, 52, 32, IMG_COLOR_STYLED);
		imageline($img, 88, 10, 88, 32, IMG_COLOR_STYLED);
		imageline($img, 124, 10, 124, 32, IMG_COLOR_STYLED);
		imageline($img, 14, 15, 161, 15, IMG_COLOR_STYLED);
		imageline($img, 14, 27, 161, 27, IMG_COLOR_STYLED);
		imagestring($img, 1, 8, 18, "0", $text);
		imagestring($img, 1, 164, 18, "24", $text);

	} else { // バーコード・スペアナ
		$col[11] = imagecolorallocate($img, $chart[$chcolor][11], $chart[$chcolor][11], $chart[$chcolor][11]);
		imagefilledrectangle($img, 14, 10, 161, 20, $background);
		imagestring($img, 1, 13, 21, "0", $text);
		imagestring($img, 1, 50, 21, "6", $text);
		imagestring($img, 1, 84, 21, "12", $text);
		imagestring($img, 1, 120, 21, "18", $text);
		imagestring($img, 1, 156, 21, "24", $text);
	}
	imagestring($img, 1, 5, 1, "B L O G T I M E S", $text);

	$y1 = array(
		"0" => array(10, 10, 10, 10, 10, 10, 10, 10, 10, 10, 10, 20), 
		"1" => array(10, 11, 12, 13, 14, 15, 16, 17, 18, 19, 20, 20),
		"2" => array(10, 11, 12, 13, 14, 15, 16, 17, 18, 19, 20, 21)
	);
	$y2 = array(
		"0" => array(20, 20, 20, 20, 20, 20, 20, 20, 20, 20, 20, 20),
		"1" => array(20, 20, 20, 20, 20, 20, 20, 20, 20, 20, 20, 20),
		"2" => array(32, 31, 30, 29, 28, 27, 26, 25, 24, 23, 22, 21)
	);
	if ($type != 1) { // バーコード・音波形
		$col[0] = imagecolorallocate($img, $chart[$chcolor][0], $chart[$chcolor][0], $chart[$chcolor][0]);
		$col[1] = imagecolorallocate($img, $chart[$chcolor][1], $chart[$chcolor][1], $chart[$chcolor][1]);
		$col[2] = imagecolorallocate($img, $chart[$chcolor][2], $chart[$chcolor][2], $chart[$chcolor][2]);
		$col[3] = imagecolorallocate($img, $chart[$chcolor][3], $chart[$chcolor][3], $chart[$chcolor][3]);
		$col[4] = imagecolorallocate($img, $chart[$chcolor][4], $chart[$chcolor][4], $chart[$chcolor][4]);
		$col[5] = imagecolorallocate($img, $chart[$chcolor][5], $chart[$chcolor][5], $chart[$chcolor][5]);
		$col[6] = imagecolorallocate($img, $chart[$chcolor][6], $chart[$chcolor][6], $chart[$chcolor][6]);
		$col[7] = imagecolorallocate($img, $chart[$chcolor][7], $chart[$chcolor][7], $chart[$chcolor][7]);
		$col[8] = imagecolorallocate($img, $chart[$chcolor][8], $chart[$chcolor][8], $chart[$chcolor][8]);
		$col[9] = imagecolorallocate($img, $chart[$chcolor][9], $chart[$chcolor][9], $chart[$chcolor][9]);
		$col[10] = imagecolorallocate($img, $chart[$chcolor][10], $chart[$chcolor][10], $chart[$chcolor][10]);
	
		for ($i = 0; $i < 144; $i++) {
		$x = $i * 1 + 16;
			switch (TRUE) {
				case ($data[$i] / $current == 1):
					imageline($img, $x, $y1[$type][0], $x, $y2[$type][0], $col[0]);
					break;
				case ($data[$i] / $current > 0.9):
					imageline($img, $x, $y1[$type][1], $x, $y2[$type][1], $col[1]);
					break;
				case ($data[$i] / $current > 0.8):
					imageline($img, $x, $y1[$type][2], $x, $y2[$type][2], $col[2]);
					break;
				case ($data[$i] / $current > 0.7):
					imageline($img, $x, $y1[$type][3], $x, $y2[$type][3], $col[3]);
					break;
				case ($data[$i] / $current > 0.6):
					imageline($img, $x, $y1[$type][4], $x, $y2[$type][4], $col[4]);
					break;
				case ($data[$i] / $current > 0.5):
					imageline($img, $x, $y1[$type][5], $x, $y2[$type][5], $col[5]);
					break;
				case ($data[$i] / $current > 0.4):
					imageline($img, $x, $y1[$type][6], $x, $y2[$type][6], $col[6]);
					break;
				case ($data[$i] / $current > 0.3):
					imageline($img, $x, $y1[$type][7], $x, $y2[$type][7], $col[7]);
					break;
				case ($data[$i] / $current > 0.2):
					imageline($img, $x, $y1[$type][8], $x, $y2[$type][8], $col[8]);
					break;
				case ($data[$i] / $current > 0.1):
					imageline($img, $x, $y1[$type][9], $x, $y2[$type][9], $col[9]);
					break;
				case ($data[$i] / $current > 0):
					imageline($img, $x, $y1[$type][10], $x, $y2[$type][10], $col[10]);
					break;
				default:
					imageline($img, $x, $y1[$type][11], $x, $y2[$type][11], $col[11]);
					break;
			}
		}
	} else { // スペアナ
		if ($chcolor) { // タイムライン白背景
			$col[0] = imagecolorallocate($img, 255, 0, 0);
			$col[1] = imagecolorallocate($img, 255, 0, 0);
			$col[2] = imagecolorallocate($img, 255, 0, 15);
			$col[3] = imagecolorallocate($img, 255, 0, 31);
			$col[4] = imagecolorallocate($img, 255, 0, 63);
			$col[5] = imagecolorallocate($img, 255, 0, 95);
			$col[6] = imagecolorallocate($img, 255, 0, 127);
			$col[7] = imagecolorallocate($img, 255, 0, 159);
			$col[8] = imagecolorallocate($img, 255, 0, 191);
			$col[9] = imagecolorallocate($img, 223, 0, 223);
			$col[10] = imagecolorallocate($img, 191, 0, 255);
		} else { // タイムライン黒背景
			$col[0] = imagecolorallocate($img, 255, 0, 0);
			$col[1] = imagecolorallocate($img, 255, 0, 0);
			$col[2] = imagecolorallocate($img, 255, 0, 0);
			$col[3] = imagecolorallocate($img, 255, 31, 0);
			$col[4] = imagecolorallocate($img, 255, 63, 0);
			$col[5] = imagecolorallocate($img, 255, 127, 0);
			$col[6] = imagecolorallocate($img, 255, 191, 0);
			$col[7] = imagecolorallocate($img, 255, 255, 0);
			$col[8] = imagecolorallocate($img, 195, 255, 0);
			$col[9] = imagecolorallocate($img, 127, 255, 0);
			$col[10] = imagecolorallocate($img, 0, 255, 0);
		}
		for ($i = 0; $i < 144; $i++) {
			$x = $i * 1 + 16;
			switch (TRUE) {
				case ($data[$i] / $current == 1):
					imageline($img, $x, $y1[$type][0], $x, $y2[$type][0], $col[0]);
				case ($data[$i] / $current > 0.9):
					imageline($img, $x, $y1[$type][1], $x, $y2[$type][1], $col[1]);
				case ($data[$i] / $current > 0.8):
					imageline($img, $x, $y1[$type][2], $x, $y2[$type][2], $col[2]);
				case ($data[$i] / $current > 0.7):
					imageline($img, $x, $y1[$type][3], $x, $y2[$type][3], $col[3]);
				case ($data[$i] / $current > 0.6):
					imageline($img, $x, $y1[$type][4], $x, $y2[$type][4], $col[4]);
				case ($data[$i] / $current > 0.5):
					imageline($img, $x, $y1[$type][5], $x, $y2[$type][5], $col[5]);
				case ($data[$i] / $current > 0.4):
					imageline($img, $x, $y1[$type][6], $x, $y2[$type][6], $col[6]);
				case ($data[$i] / $current > 0.3):
					imageline($img, $x, $y1[$type][7], $x, $y2[$type][7], $col[7]);
				case ($data[$i] / $current > 0.2):
					imageline($img, $x, $y1[$type][8], $x, $y2[$type][8], $col[8]);
				case ($data[$i] / $current > 0.1):
					imageline($img, $x, $y1[$type][9], $x, $y2[$type][9], $col[9]);
				case ($data[$i] / $current > 0):
					imageline($img, $x, $y1[$type][10], $x, $y2[$type][10], $col[10]);
					break;
			}
		}
	}

	$chart = BLOGN_MODDIR.'blogtimes/chart.png';
	imagepng($img, $chart);
	imagedestroy($img);
	return TRUE;
}

function blogn_mod_blogtimes_convert($logs) {
	$arr = array();
	$count = count($logs[1]);
	for ($i = 0; $i < $count; $i++) {
		$minutes = (int) substr($logs[1][$i]["date"], 8, 2) * 60 + (int) substr($logs[1][$i]["date"], 10, 2);
		$section = floor($minutes / 10);
		$arr[$section] += 1;
	}
	return $arr;
}

?>
